package ca.uwaterloo.crysp.attacktouchalytics;

import java.util.ArrayList;
import java.util.Arrays;

import ca.uwaterloo.crysp.attacktouchalytics.R;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Color;
import android.media.AudioManager;
import android.media.ToneGenerator;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.Window;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.TextView;

public class DebugActivity extends Activity {
	static Activity activity;
	static final int WINSIZE = 8;
	static int ctr = 0;
	static ArrayList<Integer> winScore;
	static ArrayList<Integer> sessionScore = new ArrayList<Integer>();
	static ArrayList<Character> pastWinScore;
	public static String [] dir = {"Up", "Down", "Left", "Right"};
	static int state = 0;
	static final int TRACE_STATE = 0;
	static String lastResult = "N/A";
	//static final int BLIND_TEXT_STATE = 1;
	//static final int TEXT_STATE = 2;
	static final int BLIND_TEST_STATE = 1;
	static final int TEST_STATE = 2;
	static final int NUM_STATES = 3;
	static final int [] MAX_ATTEMPTS = {80,8,80};	//against each state
	private static WebView webview;
	static ArrayList<String> pics;
	static int picIndex = 0;
	static boolean failFlag = false, finishFlag = false;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		this.requestWindowFeature(Window.FEATURE_NO_TITLE);
		setContentView(R.layout.activity_debug);
		activity = this;
		winScore = new ArrayList<Integer>();
		pastWinScore = new ArrayList<Character>();
		webview = (WebView) activity.findViewById(R.id.webView);
		webview.getSettings().setJavaScriptEnabled(true);
		webview.setWebViewClient(new WebViewClient());
		state = TEST_STATE;
		updateState(false);
		Intent intent = new Intent(this, TracingActivity.class);
        startActivity(intent);
	}
	@Override
	public void finish() {
		ModelStorage.writeToFile(MainActivity.user,	"END_MIMICRY;"+
				MainActivity.user+";"+MainActivity.victims.get(MainActivity.victim)
				+";"+MainActivity.direction);
		
		state = 0;
		finishFlag = false;
		Intent intent = this.getIntent();
		this.setResult(RESULT_OK, intent);
		TracingActivity.tracingActivity.finish();
		super.finish();
	}
	
	static void postProcessSwipe(int score, double [] diff, double [] targetFV, 
			double []fv) {
		setText(activity.findViewById(R.id.debugTextResult), Color.BLACK, "");
		//Return if incorrect swipe direction
		if ((int)fv[22] != MainActivity.direction) { 
			setText(activity.findViewById(R.id.debugTextResult), Color.GRAY,
					"Please swipe " + dir[MainActivity.direction]);
			return;
		}
		if (MainActivity.direction == 2 && state != TRACE_STATE) {
			picIndex = (picIndex+1)%imgViews.length;
			webview.loadDataWithBaseURL(null, pics.get(picIndex), "text/html", "utf-8",null);
			
		}
		ctr++;
		winScore.add(score);
		sessionScore.add(score);
		
		/*if (state != BLIND_TEST_STATE)
			updateSwipeResult(score, targetFV, fv);*/
		if (state == TRACE_STATE)	
			updateRoundInfo();
		logStats(score, diff, targetFV, fv);
		if (winScore.size() == 8 || ctr == MAX_ATTEMPTS[state]) 
			if(evaluateState()) {
				if (state < NUM_STATES - 1)
					state++;
				updateState(false);
			}
		
	}
	private static void writePhaseWrapper(boolean isBegin, int _state, char res, 
			boolean wrapperCalled) {
		String strIsWrapper;
		if (wrapperCalled)	strIsWrapper = "RETRY";
		else	strIsWrapper = "!RETRY";
		if (isBegin)
			ModelStorage.writeToFile(MainActivity.user, "BEGIN_PHASE;" +_state
					+";" + strIsWrapper+";"+MainActivity.user+";" +
					MainActivity.victims.get(MainActivity.victim)+";"+
					MainActivity.direction);
		else
			ModelStorage.writeToFile(MainActivity.user, "END_PHASE;" +_state+";" 
					+ strIsWrapper+";"+MainActivity.user+";" +
					MainActivity.victims.get(MainActivity.victim)+";"+ 
					MainActivity.direction +";"+res+";"+popSessionScores());
	}

	private static boolean evaluateState() {
		char winResult = 'F';
		int scoreSum = 0; for (int i : winScore)	if (i == 1)	scoreSum++;
		winScore.clear();
		if (scoreSum > WINSIZE/2)	winResult = 'S';
		//only one state permitted for attack
		if (state == TEST_STATE) {
			writePhaseWrapper(false, state, winResult, false);
			ctr = 0;
			pastWinScore.clear();
			if (winResult == 'S') {
				TracingActivity.showFinishDialog("Success"); lastResult = "Success";}
			else {
				TracingActivity.showFinishDialog("Failure");lastResult = "Failure";}
			return false;
		}

		if (state == BLIND_TEST_STATE) { //one round only states
			writePhaseWrapper(false, state, winResult, false);
			return true;
		}
		else if (state == TRACE_STATE){ // >1 round states
			pastWinScore.add(winResult);
			if (winResult == 'S' && pastWinScore.size() > 1 &&
					pastWinScore.get(pastWinScore.size()-2) == 'S' ) {	
				writePhaseWrapper(false, state, winResult, false);
				return true;
			}
		}
		else if (state == TEST_STATE) {
			pastWinScore.add(winResult);
			if (winResult == 'S' && pastWinScore.size() > 1 &&
					pastWinScore.get(pastWinScore.size()-2) == 'S' ) {	
				writePhaseWrapper(false, state, winResult, false);
				TracingActivity.setFinishLinkState(true);
				return true;
			}
		}
		if (ctr == MAX_ATTEMPTS[state]) {
			writePhaseWrapper(false, state, 'F', false);
			failFlag = true;
			return true;
		}
		return false;
	}
	public static void wrapperUpdateState(int _state) {
		state = _state;
		updateState(true);
	}
	private static void updateState(boolean wrapperCalled) {
		int [] roundIds = {R.id.R1,R.id.R2,R.id.R3,R.id.R4,R.id.R5,R.id.R6,
				R.id.R7,R.id.R8,R.id.R9,R.id.R10};
		//clear ctr from past session
		sessionScore.clear(); ctr = 0;	winScore.clear();	pastWinScore.clear();
		
		if (finishFlag && !wrapperCalled) {
			TracingActivity.showFinishDialog();
			return;
		}
		if (failFlag && state == BLIND_TEST_STATE) { //failed after trace_state
			failFlag = false;
			finishFlag = true;
			TracingActivity.showFinishDialog();
		}
		
		if (state != NUM_STATES)
			writePhaseWrapper(true, state, 'X', wrapperCalled);
		failFlag = false;
		setText(activity.findViewById(R.id.debugTextResult), Color.BLACK, "");
		if (state == TRACE_STATE) {
			for (int id : roundIds) 
				(activity.findViewById(id)).setVisibility(View.VISIBLE);
			(activity.findViewById(R.id.webView)).setVisibility(View.GONE);
			updateRoundInfo();
		}
		else {
			for (int id : roundIds) 
				(activity.findViewById(id)).setVisibility(View.GONE);
			(activity.findViewById(R.id.webView)).setVisibility(View.VISIBLE);
			if (state == BLIND_TEST_STATE) {
				TracingActivity.showPhaseDialog("Experimental Round", 
						"Put the device down, then pick and swipe like the victim. " +
						"Feedback will not be available for this round");
				if (MainActivity.direction == 0) 
					webview.loadDataWithBaseURL(null, getPage(true), "text/html", "utf-8",null);
				else {
					pics = new ArrayList<String>(Arrays.asList(imgViews));
					webview.loadDataWithBaseURL(null, pics.get(0), "text/html", "utf-8",null);
				}
			}
			else if (state == TEST_STATE) {
				/*TracingActivity.showPhaseDialog("Test rounds", 
						"Put the device down, then pick and swipe like the victim. " +
						"Feedback will be provided for failed attempts.");*/
				if (MainActivity.direction == 0) 
					webview.loadDataWithBaseURL(null, getPage(false), "text/html", "utf-8",null);
				else {
					pics = new ArrayList<String>(Arrays.asList(imgViews));
					webview.loadDataWithBaseURL(null, pics.get(0), "text/html", "utf-8",null);
				}
				webview.scrollTo(0, 0);
			}
			
			else if (state == NUM_STATES) {
				MainActivity.passageIndex++;
				MainActivity.passageIndex %= readingPassages.length;
				finishFlag = true;
				TracingActivity.showFinishDialog();
			}
		}
	}
	private static void updateSwipeResult(int score, double [] targetFV, double [] fv) {
		if (score == 1)
			setText(activity.findViewById(R.id.debugTextResult), Color.GREEN, 
					"Accepted");
		if (score == -1)
			setText(activity.findViewById(R.id.debugTextResult), 
					Color.RED, getHint(targetFV, fv));
	}
	private static void logStats(int score, double [] diff, double [] targetFV, 
			double []fv) {
		StringBuilder sb = new StringBuilder();
		sb.append(MainActivity.user);	sb.append(";");
		sb.append(MainActivity.victims.get(MainActivity.victim));	sb.append(";");
		sb.append(score);	sb.append(";");
		for (double d: diff) { sb.append(d);	sb.append(',');}
		sb.deleteCharAt(sb.length()-1);	sb.append(";");
		for (double d: targetFV) { sb.append(d);	sb.append(',');}
		sb.deleteCharAt(sb.length()-1);	sb.append(";");
		for (double d: fv) { sb.append(d);	sb.append(',');}
		sb.deleteCharAt(sb.length()-1);	sb.append(";");
		sb.append(state);
		ModelStorage.writeToFile(MainActivity.user,sb.toString());
	}
	private static void updateRoundInfo() {
		int [] roundIds = {R.id.R1,R.id.R2,R.id.R3,R.id.R4,R.id.R5,R.id.R6,
				R.id.R7,R.id.R8,R.id.R9,R.id.R10};
		for (int i = 0 ; i < 10; i++) {
			StringBuilder sb = new StringBuilder();
			sb.append("ROUND "+ (i+1) + ": ");
			int roundSum = 0;
			int roundScores = 0;
			if (sessionScore.size() > i*8) {
				int j = i*8;
				roundScores = Math.min(j+8, sessionScore.size());
				for (; j < roundScores; j++) {
					if (sessionScore.get(j) == 1) {
						sb.append('\u2713'); 
						roundSum++;
					}
					else
						sb.append('\u2717');
				}
				if (roundScores == (i*8)+8) {
					if (roundSum > WINSIZE/2)
						sb.append(":      \u2714");
					else
						sb.append(":      \u2718");
				}
			}
			setText(activity.findViewById(roundIds[i]), Color.GRAY, sb.toString());
		}
	}
	public static String popSessionScores() {
		StringBuilder sb = new StringBuilder();
		for (int score : sessionScore) {
			sb.append(score); sb.append(',');
		}
		sb.deleteCharAt(sb.length()-1);
		sessionScore.clear();
		return sb.toString();
		
	}
	public static void setText(View v, int color, String text) {
		TextView tv = (TextView) v;
		tv.setTextColor(color);
		tv.setText(text);
	}

	public static String getHint(double []targetFV, double []fv) {
		int [] pIndex = {0,1,2,3, //FirstX, FirstY, LastX, LastY
						 4,7,	  //Duration, Distance
						 19,20	  //Pressure, Area covered
						};
		double [] limit = {100,100,100,100,
						  100,
						  -1,-1,
						  200,
						  -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
						  0.2, 0.1,
						  -1,-1,-1,-1,-1,-1,-1,-1,-1
				};
		for (int j = 0; j < pIndex.length; j++) {
			int i = pIndex[j];
			if (Math.abs(fv[i] - targetFV[i]) < limit[i])
				continue;

			if (i == 0) {
				if (fv[i] < targetFV[i])
					return "Move start point towards right";
				return "Move start point towards left";
			}
			else if (i == 1) {
				if (fv[i] < targetFV[i])
					return "Move start point towards bottom";
				return "Move start point towards top";
			}
			else if (i == 2) {
				if (fv[i] < targetFV[i])
					return "Move end point towards right";
				return "Move end point towards left";
			}
			else if (i == 3) {
				if (fv[i] < targetFV[i])
					return "Move end point towards bottom";
				return "Move end point towards top";
			}
			else if (i == 3) {
				if (fv[i] < targetFV[i])
					return "Increase finger width at 1st point";
				return "Decrease finger width at 1st point";
			}
			else if (i == 4) {
				if (fv[i] < targetFV[i])
					return "Draw slowly";
				return "Draw faster";
			}
			else if (i == 7) {
				if (fv[i] < targetFV[i])
					return "Increase swipe length";
				return "Decrease swipe length";
			}
			else if (i == 20) {
				if (fv[i] < targetFV[i])
					return "Increase finger width";
				return "Decrease finger width";
			}
			else if (i == 19) {
				if (fv[i] < targetFV[i])
					return "Increase finger pressure";
				return "Decrease finger pressure";
			}
		}
		return "Curvature mismatch against target curve";
	}
	public static void beep() {
		final ToneGenerator toneGenerator = new ToneGenerator(
				AudioManager.STREAM_NOTIFICATION, 100);
		toneGenerator.startTone(ToneGenerator.TONE_PROP_ACK);
	}
	
	static String getPage(boolean isTrain) {
		StringBuilder sb = new StringBuilder();
		sb.append("<html><head></head><body><p style=\"font-size:150%; color:red\">");
		if (isTrain)
			sb.append(trainingQ[MainActivity.passageIndex]);
		else
			sb.append(testQ[MainActivity.passageIndex]);
		sb.append("</p>");
		
		for (int i = 0; i < readingPassages.length; i++) {
			if (i == MainActivity.passageIndex)
				continue;
			sb.append("<p style=\"font-size:150%\">");
			sb.append(readingPassages[i]);
			sb.append("</p>");
			if (i == 8) {
				sb.append("<p style=\"font-size:150%\">");
				sb.append(readingPassages[MainActivity.passageIndex]);
				sb.append("</p>");
			}
		}
		sb.append("</body></html>");
		return sb.toString();
	}
	
	static String [] trainingQ = {
			"What is the QSWU ranking of the University of Toronto for 2014?",
			"What is the sustained speed of the pronghorn antelope for 0.8 km?",
			"Which is the largest island of Japan in terms of population?",
			"Kevin Spacey's father died in?",
			"In US, Adele's Album 19 is certified as?",
			"The third best-selling handset in the fourth quarter of 2012 is?",
			"Nicola Tesla's brother died when Tesla was:",
			"The total debt of California in 2011 was:",
			"The percentage of passenger traffic handled by FlyDubai is:",
			"What is the engineering and technology ranking for UBC in the world:",
	};
	static String [] testQ = {
			"What is the ARWU ranking of the University of Toronto for 2014?",
			"What is the maximum speed of the blackbuck antelope?",
			"The de facto capital of Tokyo is in the province of?",
			"Kevin Spacey attended his tenth grade at:",
			"Adele's album 21 was released in?",
			"The smartphone industry profits in $ for the first quarter of 2012 are?",
			"One of Nicola Tesla's sisters' name was:",
			"Per capita spending on welfare of California among other states is:",
			"The annual passenger capacity of DXB is:",
			"What is the natural sciences and mathematics ranking for UBC in Canada:",
	};
	static String [] readingPassages =		
		{
		  //P1 @ 0
		  "The THEW University Rankings of 2014-2015 rank the University " +
		  "of Toronto at 20th place globally and 1st in Canada. The " +
		  "QSWU Rankings of 2014 also place the university at 20th in the world. " +
		  "In the ARWU ranking of 2014, the University of Toronto is placed " +
		  "at 24th in the world and 1st in Canada. It is 14th in the High " +
		  "Impact Universities ranking.",
		//P2 @ 11
		  "The Cheetah can accelerate from 0 to 96.6 km/h in under three " +
		  "seconds, though endurance is limited: most Cheetahs run for only " +
		  "60 seconds at a time. On the other hand, the pronghorn antelope is the " +
		  "fastest animal over long distances with a maximum speed of 88.5 km/h. " +
		  "It can run 56 km/h for 6 km, " +
		  "67 km/h for 1.6 km and 88.5 km/h for 0.8 km. Similarly, the " +
		  "blackbuck antelope can sustain speeds of 84 km/h for over " +
		  "1.5 km at a time and has a maximum speed of 80 km/h.",
		  //P3
		  "Japan is a stratovolcanic archipelago of 6,852 islands. The four " +
		  "largest islands are Honshu, Hokkaido, Kyushu, and Shikoku, which " +
		  "together comprise about ninety-seven percent of Japan's land area. " +
		  "Japan has the world's tenth-largest population, with over 126 " +
		  "million people. Honshu's Greater Tokyo Area, which includes the " +
		  "de facto capital of Tokyo and several surrounding prefectures, " +
		  "is the largest metropolitan area in the world, with over 30 " +
		  "million residents.",
		//P4
		  "Kevin Spacey was born in South Orange, New Jersey, the son of " +
		  "Kathleen Ann (December 5, 1931  March 19, 2003), a secretary, " +
		  "and Thomas Geoffrey Fowler (June 4, 1924  December 24, 1992), " +
		  "a technical writer and data consultant. He has two older siblings: " +
		  "a sister, Julie Spacey, and a brother, Randy Spacey. He has " +
		  "Swedish  English, and Welsh ancestry. Spacey attended Northridge " +
		  "Military Academy, Canoga Park High School (in tenth and eleventh " +
		  "grades), and then Chatsworth High School in Chatsworth, " +
		  "Los Angeles, where he graduated valedictorian of his class.",
		  //P5
		  "Adele's debut album, 19, was released in 2008 to commercial and " +
		  "critical success. It certified four times platinum in the UK, " +
		  "and double platinum in the US. Her career in the US. was boosted " +
		  "by a Saturday Night Live appearance in late 2008. At the 51st " +
		  "Annual Grammy Awards, Adele received the awards for Best New " +
		  "Artist and Best Female Pop Vocal Performance. Adele released her " +
		  "second studio album, 21, in early 2011. The album was well " +
		  "received critically and surpassed the success of her debut, " +
		  "earning the singer numerous awards in 2012 including a " +
		  "record-equalling six Grammy Awards, including Album of the Year, " +
		  "two Brit Awards and three American Music Awards. The album has " +
		  "been certified 16 times platinum in the UK; in the U.S. the " +
		  "album is certified Diamond.",
		  //P6
		  "For the eight largest phone manufacturers in Q1 2012, according " +
		  "to Horace Dediu at Asymco, Apple and Samsung combined to take " +
		  "99% of industry profits. As the smartphone industry profits grew " +
		  "from $5.3 billion in the first quarter of 2010 to $14.4 billion " +
		  "in the first quarter of 2012 , Apple had managed to increase its " +
		  "share of these profits. In the fourth quarter of 2012, the " +
		  "iPhone 5 and iPhone 4S were the best-selling handsets with sales " +
		  "of 27.4 million (13% of smartphones worldwide) and 17.4 million " +
		  "units, respectively, with the Samsung Galaxy S III in third with " +
		  "15.4 million. While Samsung has led in worldwide sales of " +
		  "smartphones, Apple's iPhone line has still managed to top " +
		  "Samsung's smartphone offerings in the United States, with 21.4% " +
		  "share and 37.8% in that market, respectively.",
		//P7
		  "Nikola Tesla was born on 10 July 1856 to Serbian parents in the " +
		  "village of Smiljan, Austrian Empire. His father, Milutin Tesla, " +
		  "was an Orthodox priest. Tesla's mother, Duka Tesla, despite never " +
		  "having received a formal education, had a talent for making home craft " +
		  "tools, mechanical appliances, and the ability to memorize Serbian " +
		  "epic poems. Nikola credited his eidetic memory and creative " +
		  "abilities to his mother's genetics and influence. Tesla was " +
		  "the fourth of five children. He had an older brother named Dane " +
		  "and three sisters, Milka, Angelina and Marica. Dane was killed " +
		  "in a horse-riding accident when Nikola was five. In 1861, Tesla " +
		  "attended the Lower/Primary School in Smiljan where he studied " +
		  "German, arithmetic, and religion. In 1862, the Tesla family moved " +
		  "to Gospic, Austrian Empire, where Tesla's father worked as a pastor.", 
		  //P8
		  "California state spending increased from $56 billion in 1998 to " +
		  "$127 billion in 2011. California, with 12% of the U.S. " +
		  "population, has one-third of the nation's welfare recipients. " +
		  "California has the third highest per capita spending on welfare " +
		  "among the states, as well as the highest spending on welfare at " +
		  "$6.67 billion. In January 2011, California's total debt was " +
		  "at least $265 billion. On June 27, 2013, Governor Jerry Brown " +
		  "signed a balanced budget (no deficit) for the state, its first " +
		  "in decades; however the state's debt remains at $132 billion. " +
		  "California now levies a 13.3% maximum marginal income tax rate " +
		  "with ten tax brackets, ranging from 1%  to 13.3%. California has " +
		  "a state sales tax of 7.5%.",
		  //P9
		  "Dubai International Airport (DXB) is an international airport " +
		  "serving Dubai. It is a major airline hub in the Middle East, and " +
		  "is the main airport of Dubai. The airport is operated by the " +
		  "Dubai Airports Company and is the home base of Dubai's " +
		  "international airlines, Emirates, FlyDubai and Emirates " +
		  "SkyCargo; the Emirates hub is the largest airline hub in the " +
		  "Middle East; Emirates handles 64% of all passenger " +
		  "traffic, and accounts for about 50% of all aircraft " +
		  "movements at the airport. Dubai Airport is also the base for " +
		  "low-cost carrier, FlyDubai which handles 10.7% of " +
		  "passenger traffic at DXB. The airport became a secondary hub for " +
		  "Qantas in April 2013. The airport consists of three terminals and " +
		  "has a total capacity of 80 million passengers annually. In 2013 " +
		  "DXB handled a record 66.4 million in passenger traffic, a 15.2% " +
		  "increase over 2012. This made it the 7th busiest airport in the " +
		  "world by passenger traffic and the 2nd busiest airport in the " +
		  "world by international passenger traffic.",
		  //P10
		  "In 2012, U.S. News and World Report ranked UBC 22nd worldwide " +
		  "in the field of Politics and International Relations. In the 2011 " +
		  "ARWU rankings for social sciences, the university was ranked 32nd " +
		  "in the world and first in Canada. In the field of life sciences, " +
		  "the 20122013 Times rankings placed the university 20th in the " +
		  "world, and first nationally. The 2011 ARWU rankings for life " +
		  "sciences placed the university 36th in the world and second in " +
		  "Canada. In natural sciences and mathematics, the university was " +
		  "ranked 5175th in the world, and second in Canada. In the field " +
		  "of physical sciences, the Times rankings placed the university " +
		  "35th in the world, and second in Canada. Additionally, in the " +
		  "field of engineering and technology, UBC placed 33rd in the world " +
		  "and second in Canada. Finally, the 20122013 Times Higher " +
		  "Education World University Rankings ranked the university 40th " +
		  "in the world and third in Canada in the field of arts and " +
		  "humanities.",
		};	
	static String [] imgViews = {
			"<html><head></head><body><img src=\"file:///android_asset/img/c1.jpg\" width=\"100%\"><p>1</p></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/c2.jpg\" width=\"100%\"><p>2</p></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/c3.jpg\" width=\"100%\"><p>3</p></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/c4.jpg\" width=\"100%\"><p>4</p></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/c5.jpg\" width=\"100%\"><p>5</p></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/c6.jpg\" width=\"100%\"><p>6</p></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/c7.jpg\" width=\"100%\"><p>7</p></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/c8.jpg\" width=\"100%\"><p>8</p></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/c9.jpg\" width=\"100%\"><p>9</p></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/c10.jpg\" width=\"100%\"><p>10</p></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/c11.jpg\" width=\"100%\"><p>11</p></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/c12.jpg\" width=\"100%\"><p>12</p></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/c13.jpg\" width=\"100%\"><p>13</p></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/c14.jpg\" width=\"100%\"><p>14</p></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/c15.jpg\" width=\"100%\"><p>15</p></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/c16.jpg\" width=\"100%\"><p>16</p></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/d1.jpg\" width=\"100%\"><p>17</p></body></html>",
			"<html><head></head><body><img src=\"file:///android_asset/img/d2.jpg\" width=\"100%\"><p>18</p></body></html>",
	};
}
