package ca.uwaterloo.crysp.attacktouchalytics;

import java.util.ArrayList;
import java.util.List;

import ca.uwaterloo.crysp.attacktouchalytics.R;
import ca.uwaterloo.crysp.attacktouchalytics.MultiSpinner.MultiSpinnerListener;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.Window;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.Spinner;
import android.widget.TextView;
import android.view.View;


public class MainActivity extends Activity implements MultiSpinnerListener{
	static final int LAUNCH_ATTACK = 1;
	static String user = null;
	static List<String> victims;
	static int victim = 0;
	static int direction = -2;
	static Context mainActivity;
	public static int featureSetSize = 29;
	List<String> users; 
	static ArrayList<Data> ds = new ArrayList<Data>();
	static SVMClassifier svm;
	static KNNClassifier knn;
	static ArrayList<double[]> trainingSet;
	static ArrayList<double[]> positive;
	static ArrayList<Integer> trainingLabels;
	static ArrayList<ArrayList<TouchPoint>> victimRawTP = 
			new ArrayList<ArrayList<TouchPoint>>();
	static ArrayList<String> victimRaw = new ArrayList<String>();
	static int targetIndex = -1;
	public static int passageIndex = 4;
	
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        this.requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.activity_main);
        
        mainActivity = this;
        users = ModelStorage.getModels();
        victims = new ArrayList<String>(); 
        populateExistingUsersSpinner();
        populateVictimsSpinner();
        final Button button = (Button) findViewById(R.id.begin_button);
        button.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				if (user == null) {
					String textEntry = ((TextView) findViewById(R.id.user_name)).getText().toString();
					if (textEntry.length() > 0) {
						user = textEntry;
						Log.e(user, user);
					}
				}
				if (victims.size() == 0 || user == null)// || direction == -1)
					return;
				View view = findViewById(R.id.victims_spinner);
    			view.setVisibility(View.INVISIBLE);
    			view = findViewById(R.id.existing_users_spinner);
    			view.setVisibility(View.INVISIBLE);
    			view = findViewById(R.id.user_name);
    			view.setVisibility(View.INVISIBLE);
    			view = findViewById(R.id.new_user_label);
    			view.setVisibility(View.INVISIBLE);
    			button.setVisibility(View.INVISIBLE);
				startNextAttack();
				/*TextView tv = (TextView) findViewById(R.id.info_text);
				tv.setText("Please wait while dataset is loaded and " +
						"classifier is trained");
				button.setVisibility(View.INVISIBLE);
				new LoadAndTrainTask().execute();*/
				//loadDS();
				//trainClassifier();
				//Intent intent = new Intent(mainActivity, DebugActivity.class);
                //startActivity(intent);
			}
        });
    }
    
    private void populateExistingUsersSpinner() {
    	Spinner spinner = (Spinner) findViewById(R.id.existing_users_spinner);
    	final List<String> list = new ArrayList<String>();
    	list.add("Please select your name");
    	list.addAll(users);
    	ArrayAdapter<String> dataAdapter = new ArrayAdapter<String>(this,
    			android.R.layout.simple_spinner_dropdown_item, list);
    	dataAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
    	spinner.setAdapter(dataAdapter);
    	spinner.setOnItemSelectedListener(new OnItemSelectedListener() 
    	{
    		@Override
    		public void onItemSelected(AdapterView<?> parentView, 
    				View selectedItemView, int position, long id) 
    		{
    			if (position != 0) {
    				user = list.get(position);
    				populateVictimsSpinner();
    			}
    		}
    		@Override
    		public void onNothingSelected(AdapterView<?> parentView) 
    		{
    		}
    	});
    }
    
    /*private void populateScrollingDirectionSpinner() {
    	Spinner spinner = (Spinner) findViewById(R.id.direction_spinner);
    	List<String> list = new ArrayList<String>();
    	list.add("Select training swipe direction");
    	list.add("Up"); list.add("Down"); list.add("Left"); list.add("Right");
    	ArrayAdapter<String> dataAdapter = new ArrayAdapter<String>(this,
    			android.R.layout.simple_spinner_dropdown_item, list);
    	dataAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
    	spinner.setAdapter(dataAdapter);
    	spinner.setOnItemSelectedListener(new OnItemSelectedListener() 
    	{
    		@Override
    		public void onItemSelected(AdapterView<?> parentView, 
    				View selectedItemView, int position, long id) 
    		{
    			if (position != 0) {
    				direction = position - 1;
    				//dataset = new Dataset(user, direction*1.0);
    				//kc = new KNNClassifier(5, 11, dataset.data);
    				//kc.train(user);
    				populateVictimsSpinner();
    			}
    		}

    		@Override
    		public void onNothingSelected(AdapterView<?> parentView) 
    		{
    		}
    	});
    }*/
    private void populateVictimsSpinner() {
    	MultiSpinner multiSpinner = (MultiSpinner) findViewById(R.id.victims_spinner);
    	final List<String> list = new ArrayList<String>();
    	for (String v : users)
    		if (!v.equals(user))
    			list.add(v);
    	
    	multiSpinner.setItems(list, "Select victims", this);
    }
	public void launchDebugActivity() {
		ModelStorage.writeToFile(user, 
				"BEGIN_MIMICRY;"+user+";"+victims.get(victim)+";"+direction);
		Intent intent = new Intent(this, DebugActivity.class);
        startActivityForResult(intent, LAUNCH_ATTACK);
	}
    public static void loadDS() {
    	ds.clear();
    	victimRawTP.clear();
    	victimRaw.clear();
		ArrayList<String> users = ModelStorage.getModels();
		for (String user : users) {
			List<String> lines = ModelStorage.readModel(user);
			ArrayList<double[]> fvs = new ArrayList<double[]>();
			
			for (String line : lines) {
				double dir = 0;
				try{dir = Double.parseDouble(
						(line.split("\\|")[1]).split(",")[22]);
				} catch (Exception e) {Log.e("",line); System.exit(1);}
				if (dir != direction)
					continue;
				/*ArrayList <TouchPoint> tps = 
						ModelStorage.getTouchPointsFromString(line);
				if (tps.size() < 5) 
					continue;
				if (user.equals(victims.get(victim)))
					victimRaws.add(tps);
				double [] fv = TouchFeatures.TouchPointsToFV(tps);*/
				if (user.equals(victims.get(victim)))
					victimRaw.add(line);
				double [] fv = ModelStorage.getFVFromString(line);
				fvs.add(fv);
			}
			
			Data data = new Data(fvs, user);
			ds.add(data);
		}
	}
    public static void populateRaw(){
		victimRawTP.add(ModelStorage.getTouchPointsFromString(
				victimRaw.get(targetIndex)));
	}

    static Data getUserFV(String user) {
		for (Data d : ds)
			if (d.userName.equals(user))
				return d;
		return null;
	}
    
    static int trainClassifier() {
		trainingSet = new ArrayList<double[]>();
		trainingLabels = new ArrayList<Integer>();
		positive = getUserFV(victims.get(victim)).fvs; 
		int sampleSize = positive.size()/2;
		int samplePerUser = (int) Math.floor((sampleSize*1.0)/(ds.size()-2));
		int lc = 0;
		
		for(; lc < Math.min(sampleSize, positive.size()); lc++) {
			trainingSet.add(positive.get(lc));
			trainingLabels.add(1);
		}
		for (int j = 0; j < ds.size(); j++) {
			if (ds.get(j).userName.equals(victims.get(victim)) || 
					ds.get(j).userName.equals(user))
				continue;
			ArrayList<double[]> n = ds.get(j).fvs;
			lc = 0;
			for (; lc < Math.min(samplePerUser, n.size()); lc++) {
				trainingSet.add(n.get(lc));
				trainingLabels.add(-1);
			}
		}
		
		if (trainingSet.size() < 10)
			return -1;

		svm = new SVMClassifier(featureSetSize);
		svm.train(trainingSet, trainingLabels);
		knn = new KNNClassifier(5, featureSetSize);
		knn.train(trainingSet, trainingLabels);
		
		return 1;
    }
    public void startNextAttack() {
    	TextView tv = (TextView) findViewById(R.id.info_text);
    	direction += 2;
    	if (direction > 2) { //move to next user
    		if (++victim >= victims.size()){
    			tv.setText("Mimicry attacks completed. Please return the device");
    			return;//Finish. All attacks scenarios completed
    		}
    		direction = 0;
    	}
    	
		tv.setText("Please wait for training to complete for " +
				victims.get(victim) + " for "+ DebugActivity.dir[direction] 
				+ " swipes");
		new LoadAndTrainTask().execute();
    }
    public class LoadAndTrainTask extends AsyncTask<String, Integer, String> {
    	@Override
    	protected String doInBackground(String... params) {
    		loadDS();
    		int rv = trainClassifier();
    		if (rv == -1)
    			return "Failure";
    		return "Success";
    	}
    	@Override
    	protected void onPostExecute(String result) {
    		if (result.equals("Success"))
    			launchDebugActivity();
    		else
    			startNextAttack();
    		//super.onPostExecute(result);
    	}
    }

	@Override
	public void onItemsSelected(List<String> selected) {
		victims = selected;
	}
	
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
	    // Check which request we're responding to
	    if (requestCode == LAUNCH_ATTACK) {
	    	startNextAttack();
	        }
	}
}
